#!/usr/bin/python
# -*- coding: UTF-8 -*-
from twisted.internet import reactor
from autobahn.twisted.websocket import WebSocketServerProtocol, WebSocketServerFactory

port = 28563
concurrentClientCount = 0

class ProcessClient(WebSocketServerProtocol):
    
    def onConnect(self, request):
        global concurrentClientCount
        concurrentClientCount += 1
        print("Client connecting: {0}".format(request.peer))
        print(concurrentClientCount, "concurrent clients are connected")

    def onClose(self, wasClean, code, reason):
        global concurrentClientCount
        concurrentClientCount -= 1
        print("WebSocket connection closed: {0}".format(reason))

    def onMessage(self, data, isBinary):
        #self - это клиент
        if isBinary:
          print("Can't anwer to binary message")
          return
        data = data.decode('utf8')
        print("Data received: "+data)
        words = data.split(" ")
        answer = str(eval(words[2]+words[1]+words[3]))
        self.sendMessage(answer.encode('utf8'), False)
        print("Answer: "+answer)

factory = WebSocketServerFactory(u"ws://0.0.0.0:"+str(port))
factory.protocol = ProcessClient
reactor.listenTCP(port, factory)
reactor.run()
